import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
/**
 * Write a description of class Button here.
 * 
 * @author Taylor Born
 * @version November 2010
 */
import java.awt.Color;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics2D;
public class Button  extends Actor
{
    private Point size;
    private String text;
    private boolean hover;
    private boolean pressed;
    private GreenfootImage icon = new GreenfootImage(1, 1);
    private boolean showIcon;
    private boolean clicked;
    private boolean enabled = true;

    public Button(String str, Point s)
    {
        size = s;
        text = str;
        draw();
    }
    public void act() 
    {
        if (enabled)
        {
            boolean last = hover;
            boolean lastP = pressed;
            if (Greenfoot.mouseMoved(this))
                hover = true;
            else if (Greenfoot.mouseMoved(null))
                hover = false;
            if (Greenfoot.mousePressed(this))
                pressed = true;
            if (Greenfoot.mouseClicked(this) && hover)
                clicked = true;
            if (Greenfoot.mouseClicked(null) || Greenfoot.mouseDragEnded(null))
                pressed = false;
            if (last != hover || lastP != pressed)
                draw();
        }
    }
    public void draw()
    {
        GreenfootImage pic = new GreenfootImage(size.getX(), size.getY());
        if (!enabled)
            pic.setColor(new Color(102, 102, 102));
        Graphics2D graphics = (new GreenfootImage(1, 1)).getAwtImage().createGraphics();
        graphics.setFont(new Font("New Times Roman", 20, 12));
        FontMetrics fm = graphics.getFontMetrics();
        pic.setFont(new Font("New Times Roman", 20, 12));
        pic.drawString(text, (size.getX() - fm.charsWidth((text).toCharArray(), 0, (text).length())) / 2, 16);
        graphics.dispose();
        if (pressed)
            pic.setColor(Color.GRAY);
        pic.drawRect(0, 0, size.getX() - 1, size.getY() - 1);
        if (showIcon)
            pic.drawImage(icon, 3, 4);
        if (hover)
        {
            GreenfootImage back = new GreenfootImage(size.getX(), size.getY());
            back.fill();
            back.setTransparency(25);
            GreenfootImage pic2 = new GreenfootImage(size.getX(), size.getY());
            pic2.drawImage(back, 0, 0);
            pic2.drawImage(pic, 0, 0);
            pic = pic2;
        }
        setImage(pic);
    }
    public boolean wasClicked()
    {
        boolean c = clicked;
        clicked = false;
        return c;
    }
    public void addedToWorld(World world)
    {
        hover = false;
        draw();
    }
    public void setEnable(boolean e)
    {
        enabled = e;
        draw();
    }
    public void showPic(boolean show)
    {
        showIcon = show;
        draw();
    }
    public void changeText(String str)
    {
        text = str;
        draw();
    }
}