import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;
import java.awt.Color;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics2D;
import java.io.*;
import java.util.Scanner;

/**
 * Write a description of class ControlBox here.
 * 
 * @author Taylor Born
 * @version November 2010
 */
public class ControlBox  extends Actor
{
    private ArrayList<String> a;
    private Point pos;
    private int num;
    private int level = -1;
    private boolean endGame = true;
    private boolean normal;
    private boolean go;
    //private boolean pause = true;
    private ArrayList<Ghost> ghosts;
    private Point spawn;
    private ArrayList<Point> dots;
    private int numDots;
    private ArrayList<Trigger> triggers;
    private ArrayList<Portal> portals;
    private boolean power;
    private boolean stuck;
    private int powerTime;
    private String rating;
    private int count;
    private int time;
    private String name;
    private ListBox levelSelect;
    private Button btnStart = new Button("Play", new Point(80, 23));
    private int skip;
    private int dir = -1;
    private boolean moved;
    private static final int CODE_ID = 36;

    public ControlBox()
    {
        ArrayList<String> levels = new ArrayList<String>();
        try
        {
            BufferedReader br = new BufferedReader(new InputStreamReader(getClass().getClassLoader().getResource("Levels.txt").openStream()));
            String str = br.readLine();
            while (!str.equals(""))
            {
                levels.add(str);
                for (int i = 1; i < 17; i++)
                    str = br.readLine();
            }
        }
        catch (IOException ex)
        {}
        levelSelect = new ListBox(levels);
        GreenfootImage pic = new GreenfootImage(200, 30);
        pic.drawString("Press 0 to select a level.", 20, 18);
        setImage(pic);
    }
    public void act() 
    {
        if (!endGame)
        if (go)
        {
            int n = -1;
            if (Greenfoot.isKeyDown("a"))
                n = normal ? 1 : 2;
            if (Greenfoot.isKeyDown("d"))
                n = normal ? 2 : 1;
            if (Greenfoot.isKeyDown("w"))
                n = normal ? 3 : 4;
            if (Greenfoot.isKeyDown("s"))
                n = normal ? 4 : 3;
            if (dir != n && !moved && dir != -1)
                move(dir);
            if (dir != n)
                moved = false;
            dir = n;
        }
        else if (Greenfoot.isKeyDown("space") && num > 2 && !stuck)
            num = 2;
        if (skip++ % 5 == 0)
        {
            if (skip == 51)
            {
                skip = 0;
                if (powerTime > 0)
                {
                    powerTime--;
                    if (powerTime == 0)
                        power = false;
                }
                if (num > 0)
                {
                    num--;
                    if (stuck)
                        time--;
                    update();
                    if (num == 0 && !endGame)
                    {
                        go = true;
                        stuck = false;
                    }
                }
                else if (go)
                {
                    if (time > 0)
                        time--;
                    if (time == 0)
                    {
                        endGame = true;
                        score();
                        update();
                    }
                }
            }
            if (go)
            {
                if (dir != -1)
                {
                    move(dir);
                    moved = true;
                }
            }
            if (!endGame && (num == 0 || stuck) && (power ? skip % 3 == 0 : true))
            {
                for (Ghost g : ghosts)
                {
                    if (g.getPos().getY() != -2)
                    {
                        check();
                        g.move(a);
                        update();
                        check();
                    }
                }
            }
        }
        if (Greenfoot.isKeyDown("0"))
        {
            //pause = true;
            endGame = true;
            getWorld().addObject(levelSelect, 250, 200);
        }
        else if (Greenfoot.isKeyDown("9") && level != -1 && levelSelect.getWorld() == null)
            newGame(level);
        if (levelSelect.getWorld() != null && levelSelect.getSelect() != -1 && btnStart.getWorld() == null)
            getWorld().addObject(btnStart, 300, 380);
        if (btnStart.getWorld() != null && btnStart.wasClicked())
        {
            getWorld().removeObject(levelSelect);
            getWorld().removeObject(btnStart);
            newGame(levelSelect.getSelect() + 1);
        }
        if (Greenfoot.isKeyDown("w"))
        {}
        if (Greenfoot.isKeyDown("a"))
        {}
        if (Greenfoot.isKeyDown("s"))
        {}
        if (Greenfoot.isKeyDown("d"))
        {}
    }
    public void update()
    {
        GreenfootImage pic = new GreenfootImage(500, 400);
        int size = 16;
        pic.setFont(new Font("Courier New", 10, size));
        Graphics2D graphics = (new GreenfootImage(1, 1)).getAwtImage().createGraphics();
        graphics.setFont(pic.getFont());
        FontMetrics fm = graphics.getFontMetrics();
        int w = fm.charsWidth(a.get(0).toCharArray(), 0, a.get(0).length());
        if (power)
        {
            pic.setColor(new Color(255, powerTime % 2 == 0 ? 0 : 80, 0));
            pic.fillRect(40, 40, w, 12 * size);
        }
        pic.setColor(Color.BLACK);
        for (int i = 0; i < 12; i++)
        {
            String temp = a.get(i);
            for (int k = 0; k < ghosts.size(); k++)
                if (ghosts.get(k).getPos().getY() == i)
                    temp = temp.substring(0, ghosts.get(k).getPos().getX()) + '' + temp.substring(ghosts.get(k).getPos().getX() + 1);
            if (pos.getY() == i)
                temp = temp.substring(0, pos.getX()) + 'p' + temp.substring(pos.getX() + 1);
            if (i == 5 && endGame)
                temp = temp.substring(0, 14) + "Game Over" + temp.substring(23);
            if (i == 5 && num > 0)
                if (num == 1)
                    temp = temp.substring(0, 17) + "Go!" + temp.substring(20);
                else
                    temp = temp.substring(0, 17) + "-" + (num - 1) + "-" + temp.substring(20);
            pic.drawString(temp, 40, 40 + size + size * i);
        }
        pic.drawString("Time: " + time + "\t\tScore: " + count + "/" + numDots + (!endGame ? "" : " -> " + (int)((double)count / (double)numDots * 100) + "% \"" + rating + "\""), 5, 14);
        pic.drawRect(40, 40, w, 12 * size);
        setImage(pic);
    }
    public void move(int dir)
    {
        if (dir == 1)
        {
            if (pos.getX() <= 0 && a.get(pos.getY()).charAt(36) != '#' && a.get(pos.getY()).charAt(36) != '-')
                pos = new Point(36, pos.getY());
            else if (pos.getX() != 0 && a.get(pos.getY()).charAt(pos.getX() - 1) != '#' && a.get(pos.getY()).charAt(pos.getX() - 1) != '-')
                pos.move(-1, 0);
        }
        else if (dir == 2)
        {
            if (pos.getX() >= 36 && a.get(pos.getY()).charAt(0) != '#' && a.get(pos.getY()).charAt(0) != '-')
                pos = new Point(0, pos.getY());
            else if (pos.getX() != 36 && a.get(pos.getY()).charAt(pos.getX() + 1) != '#' && a.get(pos.getY()).charAt(pos.getX() + 1) != '-')
                pos.move(1, 0);
        }
        else if (dir == 3)
        {
            if (pos.getY() <= 0 && a.get(11).charAt(pos.getX()) != '#' && a.get(11).charAt(pos.getX()) != '-')
                pos = new Point(pos.getX(), 11);
            else if (pos.getY() != 0 && a.get(pos.getY() - 1).charAt(pos.getX()) != '#' && a.get(pos.getY() - 1).charAt(pos.getX()) != '-')
                pos.move(0, -1);
        }
        else
        {
            if (pos.getY() >= 11 && a.get(0).charAt(pos.getX()) != '#' && a.get(0).charAt(pos.getX()) != '-')
                pos = new Point(pos.getX(), 0);
            else if (pos.getY() != 11 && a.get(pos.getY() + 1).charAt(pos.getX()) != '#' && a.get(pos.getY() + 1).charAt(pos.getX()) != '-')
                pos.move(0, 1);
        }
        check();
        update();
        check();
    }
    public void check()
    {
        for (Portal p : portals)
            if (p.getPos().equals(pos))
                pos = new Point(p.getDes());
        for (Trigger t : triggers)
            if (t.getPos().equals(pos))
                t.effect(a, spawn, this);
        if (dots.size() == 0)
        {
            go = false;
            //
            endGame = true;
            score();
            update();
            //
            if (CodeGenerator.haveUser())
            {
                getWorld().removeObjects(getWorld().getObjects(CodeDisplay.class));
                CodeDisplay cd = new CodeDisplay(CODE_ID);
                getWorld().addObject(cd, cd.getImage().getWidth() / 2, getWorld().getHeight() - 6);
            }
        }
        for (Ghost g : ghosts)
        {
            if (g.getPos().equals(pos))
            {
                if (power)
                {
                    if (spawn.getX() != -1 && spawn.getY() != -1)
                        g.setPos(new Point(spawn));
                    else
                        g.setPos(new Point(-2, -2));
                }
                else
                {
                    go = false;
                    endGame = true;
                    score();
                    update();
                    //
                }
            }
        }
        for (int d = 0; d < dots.size(); d++)
            if (dots.get(d).equals(pos))
            {
                count++;
                a.set(pos.getY(), a.get(pos.getY()).substring(0, pos.getX()) + " " + a.get(pos.getY()).substring(pos.getX() + 1));
                dots.remove(d--);
            }
        
        char ch = a.get(pos.getY()).charAt(pos.getX());
        switch (ch)
        {
            case '&':   time += 10; break;
            case '$':   count += 10; break;
            case '*':   time -= 5; break;
            case '^':   go = false;
                        stuck = true;
                        num = 5; break;
            case '!':   power = true;
                        powerTime = 8; break;
            case '%':   normal = false; 
                        dir = -1; break;
            case '/':   normal = true;
                        dir = -1;
        }
        if (ch != ' ' && ch != '=' && ch != '@')
            a.set(pos.getY(), a.get(pos.getY()).substring(0, pos.getX()) + " " + a.get(pos.getY()).substring(pos.getX() + 1));
    }
    public void score()
    {
        double r = (double)count / (double)numDots;
        if (r >= 1)
            rating = "Perfect!";
        else if (r >= .9)
            rating = "Super";
        else if (r >= .8)
            rating = "Great";
        else if (r >= .7)
            rating = "Very Good";
        else if (r >= .6)
            rating = "Good";
        else if (r >= .5)
            rating = "Ok";
        else if (r >= .4)
            rating = "Bad";
        else if (r >= .3)
            rating = "Awful";
        else if (r >= .2)
            rating = "Terrible";
        else
            rating = "Horrific!";
    }
    public void createGhost(int col, int row, int t)
    {
        ghosts.add(new Ghost(new Point(col, row), t));
    }
    public void newGame(int lvl)
    {
        level = lvl;
        spawn = new Point(-1, -1);
        normal = true;
//         pause = false;
        endGame = false;
        count = 0;
        go = false;
        power = false;
        ghosts = new ArrayList<Ghost>();
        dots = new ArrayList<Point>();
        time = 60;
        try
        {
            BufferedReader br = new BufferedReader(new InputStreamReader(getClass().getClassLoader().getResource("Levels.txt").openStream()));
            for (int i = 1; i <= 16 * (level - 1); i++)
                br.readLine();
            name = br.readLine();
            String strPortals = br.readLine();
            String strTriggers = br.readLine();
            portals = new ArrayList<Portal>();
            triggers = new ArrayList<Trigger>();
            a = new ArrayList<String>();
            for (int i = 0; i < 12; i++)
            {
                String temp = br.readLine();
                for (int k = 0; k < 37; k++)
                {
                    switch (temp.charAt(k))
                    {
                        case 's':   pos = new Point(k, i); break;
                        case 'g':   ghosts.add(new Ghost(new Point(k, i), 1)); break;
                        case 'G':   ghosts.add(new Ghost(new Point(k, i), 1)); ghosts.add(new Ghost(new Point(k, i), 1)); break;
                        case 'c':   ghosts.add(new Ghost(new Point(k, i), 2)); break;
                        case 'C':   ghosts.add(new Ghost(new Point(k, i), 3)); break;
                        case '@':   spawn = new Point(k, i); break;
                        case 'p':   portals.add(new Portal(new Point(k, i), new Point(Integer.parseInt(strPortals.substring(portals.size() * 7, portals.size() * 7 + 2)), Integer.parseInt(strPortals.substring(3 + portals.size() * 7, 3 + portals.size() * 7 + 2))))); break;
                        case '.':   dots.add(new Point(k, i)); break;
                        case 't':   if (strTriggers.contains(";"))
                                    {
                                        triggers.add(new Trigger(strTriggers.substring(0, strTriggers.indexOf(";")), new Point(k, i)));
                                        strTriggers = strTriggers.substring(strTriggers.indexOf(";") + 2);
                                    }
                                    else
                                        triggers.add(new Trigger(strTriggers, new Point(k, i)));
                    }
                }
                temp = temp.replace("s", " ");
                temp = temp.replace("g", " ");
                temp = temp.replace("G", " ");
                temp = temp.replace("c", " ");
                temp = temp.replace("C", " ");
                temp = temp.replace("p", "");
                temp = temp.replace("t", " ");
//                 temp = temp.replace("#", "?");
//                 temp = temp.replace(".", "");
                a.add(temp);
            }
            update();
            numDots = dots.size();
            num = 6;
            //
            
        }
        catch (IOException ex)
        {}
    }
}