import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class ListBox here.
 * 
 * @author Taylor Born
 * @version November 2010
 */
import java.util.*;
import java.awt.Color;
public class ListBox  extends Actor
{
    private ArrayList<String> strs = new ArrayList<String>();
    private int scroll;
    private int select;
    private boolean dragging;
    private Point lastMouse = new Point(-25, -25);
    
    public ListBox(ArrayList<String> s)
    {
        strs = s;
    }
    public void draw()
    {
        GreenfootImage pic = new GreenfootImage(300, 200);
        pic.setColor(Color.GRAY);
        pic.fill();
        pic.setColor(Color.BLACK);
        pic.drawRect(0, 0, 299, 199);
        GreenfootImage w = new GreenfootImage(270, 180);
        w.setColor(Color.WHITE);
        w.fill();
        for (int i = 0; i < strs.size(); i++)
        {
            if (select == i)
            {
                w.setColor(Color.YELLOW);
                w.fillRect(0, 32 * i - (int)(((double)scroll / 140d) * (strs.size() * 32 - 180)), 269, 32);
            }
            w.setColor(Color.BLACK);
            w.drawRect(0, 32 * i - (int)(((double)scroll / 140d) * (strs.size() * 32 - 180)), 269, 32);
            w.drawString(strs.get(i), 8, 32 * i - (int)(((double)scroll / 140d) * (strs.size() * 32 - 180)) + 18);
        }
        pic.drawImage(w, 5, 10);
        if (strs.size() > 8)
        {
            pic.setColor(Color.RED);
            pic.fillRect(280, 10 + scroll, 15, 40);
        }
        setImage(pic);
    }
    public void act() 
    {
        MouseInfo mouse = Greenfoot.getMouseInfo();
        if (strs.size() > 8 && Greenfoot.mousePressed(this) && mouse.getX() - (getX() - 150) > 280 && mouse.getX() - (getX() - 150) < 295 && mouse.getY() - (getY() - 100) > 10 + scroll && mouse.getY() - (getY() - 100) < 50 + scroll)
            dragging = true;
        if (Greenfoot.mouseClicked(null) || Greenfoot.mouseDragEnded(null))
            dragging = false;
        if (dragging && Greenfoot.mouseDragged(null))
        {
            scroll += mouse.getY() - lastMouse.getY();
            if (scroll < 0)
                scroll = 0;
            else if (scroll + 40 > 180)
                scroll = 140;
            draw();
            lastMouse = new Point(mouse.getX(), mouse.getY());
        }
        if (Greenfoot.mouseMoved(null))
            lastMouse = new Point(mouse.getX(), mouse.getY());
        if (Greenfoot.mousePressed(this) && mouse.getX() - (getX() - 150) > 5 && mouse.getX() - (getX() - 150) < 275 && mouse.getY() - (getY() - 100) > 10 && mouse.getY() - (getY() - 100) < 190)
        {
            for (int i = 0; i < strs.size(); i++)
                if (mouse.getY() - (getY() - 100) - 10 > 32 * i - (int)(((double)scroll / 140d) * (strs.size() * 32 - 180)) && mouse.getY() - (getY() - 100) - 10 < 32 * i - (int)(((double)scroll / 140d) * (strs.size() * 32 - 180)) + 32)
                {
                    select = i;
                    draw();
                }
        }
    }
    public void addedToWorld(World world)
    {
        scroll = 0;
        select = -1;
        draw();
    }
    public int getSelect()
    {
        return select;
    }
}